/*
 * ArgumentInfo: 引数情報
 * 注記: 実装未完 
 */

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.TreeMap;

public final class ArgumentInfo
{
	//
	// コンストラクタ
	//

//	private final String[] arguments;
	private final AbstractMap options;

	//
	// 構築子
	//
	public ArgumentInfo(
		boolean bIgnoreCase,	// 大文字小文字を区別しない
		String[] astrArg)		// 引数
	{
		if (astrArg == null) {
			throw new NullPointerException();
		}

		List argumentList = new ArrayList(astrArg.length);
		if (bIgnoreCase != false) {
			options = new TreeMap(String.CASE_INSENSITIVE_ORDER);
		}
		else {
			options = new HashMap();
		}

		for (int nIndex = 0; nIndex < astrArg.length; nIndex++) {
			String strArg = astrArg[nIndex];
			if (strArg.charAt(0) == '-'
			|| strArg.charAt(0) == '/') {
				// オプション
				int nValueIndex = strArg.indexOf(':');
				if (0 < nValueIndex) {
					options.put(strArg.substring(1, nValueIndex),
								strArg.substring(nValueIndex + 1));
				}
				else {
					options.put(strArg.substring(1), "");
				}
 			}
			else {
				// 引数
				argumentList.add(strArg);
			}
		}

	//	arguments = (String[])argumentList.toArray(new String[0]);
	}

	//
	// 状態
	//

	// 指定オプションが存在するかを返す
	public boolean hasOption(
		String strOptionName)	// オプション名
	{
		if (strOptionName == null) {
			throw new NullPointerException();
		}
		else if (strOptionName.length() == 0) {
			throw new IllegalArgumentException();
		}

		return options.containsKey(strOptionName);
	}

	// 指定オプションの値を返す
	public String getOptionValue(
		String strOptionName)	// オプション名
	{
		if (strOptionName == null) {
			throw new NullPointerException();
		}
		else if (strOptionName.length() == 0) {
			throw new IllegalArgumentException();
		}
		else if (hasOption(strOptionName) == false) {
			throw new IllegalArgumentException();
		}

		return (String)options.get(strOptionName);
	}
}
