/*
 * ImplementOperation : メインフレーム必須定義メソッドインターフェース
 */

package view;

import java.awt.event.ActionListener;
import java.awt.event.ItemListener;
import java.util.Map;

public interface ImplementOperation extends ui.ImplementOperationBase
{
	String getSelectedYearValue();
	String getSaveFileFullPath(String strDialogTitle,
								String strDefPath,
								String strDefFileName);

	void setYearChoiceListener(ItemListener listener);
	void setSaveListener(ActionListener listener);

	void setYearList(java.util.List yearList, int nYear);
	void setYear(int nSetYear);
	void setHolidayList(java.util.List holidayList);

	int showSetYearDialog(int nCurrentYear);
	void prepareExit();

	Map getAdditionalState();
	void setAdditionalState(Map properties);
}
